#include "include.hxx"

#include <string>

using llvm::OwningPtr;

class Binary {
private:
    llvm::Triple triple;
    const llvm::Target * target;
    llvm::object::ObjectFile * o;

    OwningPtr<llvm::object::Binary> binary;
    OwningPtr<const llvm::MCRegisterInfo> MRI;
    OwningPtr<const llvm::MCAsmInfo> AsmInfo;
    OwningPtr<llvm::MCModule> Mod;
    OwningPtr<llvm::MCInstPrinter> IP;
    OwningPtr<llvm::MCDisassembler> DisAsm;
    OwningPtr<const llvm::MCObjectFileInfo> MOFI;
    OwningPtr<llvm::MCContext> Ctx;
    OwningPtr<const llvm::MCInstrAnalysis> MIA;
    OwningPtr<const llvm::MCSubtargetInfo> STI;
    OwningPtr<const llvm::MCInstrInfo> MII;
    OwningPtr<llvm::MCRelocationInfo> RelInfo;
    OwningPtr<llvm::MCSymbolizer> Symzer;
public:
    Binary(const std::string& filename);

    void disassemble();

    void disassemble_functions();
};
